"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanType = void 0;
const core_1 = require("@tangential/core");
const configurable_input_type_1 = require("../configurable-input-type");
const boolean_ival_1 = require("./boolean-ival");
const Model = {
    defaultValue: false
};
class BooleanType extends configurable_input_type_1.ConfigurableInputType {
    constructor(config, key) {
        super(config || {}, key);
    }
    getInputTypeKey() {
        return BooleanType.TYPE_NAME;
    }
    isNumeric() {
        return false;
    }
    createValue(cfg, key) {
        cfg = cfg || {};
        return new boolean_ival_1.BooleanIval({
            value: (cfg.value === true || cfg.value === false) ? cfg.value : this.defaultValue
        }, key || this.$key);
    }
}
exports.BooleanType = BooleanType;
BooleanType.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_type_1.ConfigurableInputType.$model, Model);
BooleanType.TYPE_NAME = 'Boolean';
configurable_input_type_1.ConfigurableInputType.register(BooleanType);
//# sourceMappingURL=boolean-type.js.map