"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurableInputType = void 0;
const core_1 = require("@tangential/core");
const media_types_1 = require("@tangential/media-types");
const inputTypeRegistry = {};
const Model = {
    _inputTypeKey: null,
    defaultValue: null
};
class ConfigurableInputType extends media_types_1.StampedMediaType {
    constructor(config, key) {
        super(config, key);
        this._inputTypeKey = this.getInputTypeKey();
    }
    static register(inputTypeCtor) {
        inputTypeRegistry[inputTypeCtor['TYPE_NAME']] = inputTypeCtor;
    }
    static create(typeConfig, key, inputTypeKey) {
        typeConfig = typeConfig || {};
        key = key || typeConfig.$key;
        inputTypeKey = inputTypeKey || typeConfig._inputTypeKey;
        return new inputTypeRegistry[inputTypeKey](typeConfig, key);
    }
}
exports.ConfigurableInputType = ConfigurableInputType;
ConfigurableInputType.$model = core_1.ObjectUtil.assignDeep({}, media_types_1.StampedMediaType.$model, Model);
//# sourceMappingURL=configurable-input-type.js.map