"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateTimeIval = void 0;
const core_1 = require("@tangential/core");
const moment = require("moment");
const configurable_input_ival_1 = require("../configurable-input-ival");
const BROWSER_DATE_TIME_LOCAL_FORMAT = 'YYYY-MM-DDTHH:mm';
const Model = {
    value: 0,
    recordedInTimeZone: 'GMT'
};
class DateTimeIval extends configurable_input_ival_1.ConfigurableInputIval {
    constructor(config, key) {
        super(config, key);
        this.value = config.value || 0;
    }
    get uiValue() {
        return moment(this.value).format(BROWSER_DATE_TIME_LOCAL_FORMAT);
    }
    set uiValue(val) {
        this.value = moment(val, BROWSER_DATE_TIME_LOCAL_FORMAT).valueOf();
    }
}
exports.DateTimeIval = DateTimeIval;
DateTimeIval.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_ival_1.ConfigurableInputIval.$model, Model);
//# sourceMappingURL=date-time-ival.js.map