"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationType = void 0;
const core_1 = require("@tangential/core");
const number_ival_1 = require("../number/number-ival");
const number_type_1 = require("../number/number-type");
const configurable_input_type_1 = require("../configurable-input-type");
const Model = {
    max: null,
    step: 1000,
    decimalPlaces: 0,
    defaultValue: 0
};
class DurationType extends number_type_1.NumberType {
    constructor(config, key) {
        super(config || {}, key);
    }
    getInputTypeKey() {
        return DurationType.TYPE_NAME;
    }
    createValue(cfg, key) {
        cfg = cfg || {};
        return new number_ival_1.NumberIval({
            value: (0, number_type_1.isNumeric)(cfg.value) ? cfg.value : this.defaultValue
        }, key || this.$key);
    }
}
exports.DurationType = DurationType;
DurationType.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_type_1.ConfigurableInputType.$model, Model);
DurationType.TYPE_NAME = 'Duration';
configurable_input_type_1.ConfigurableInputType.register(DurationType);
//# sourceMappingURL=duration-type.js.map