import { Jsonified } from '@tangential/core';
import { ConfigurableInputType, ConfigurableInputTypeJson } from '../configurable-input-type';
import { NumberIval, NumberIvalIF } from './number-ival';
export interface NumberTypeIF extends ConfigurableInputTypeJson {
    min?: number;
    max?: number;
    step?: number;
    decimalPlaces?: number;
    defaultValue?: number;
}
export declare class NumberType extends ConfigurableInputType implements Jsonified<NumberType, NumberTypeIF>, NumberTypeIF {
    static $model: NumberTypeIF;
    static TYPE_NAME: string;
    min?: number;
    max?: number;
    step?: number;
    decimalPlaces?: number;
    defaultValue?: number;
    constructor(config?: NumberTypeIF, key?: string);
    getInputTypeKey(): string;
    isNumeric(): boolean;
    createValue(cfg?: NumberIvalIF, key?: string): NumberIval;
}
export declare function isNumeric(value: any): boolean;
