"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNumeric = exports.NumberType = void 0;
const core_1 = require("@tangential/core");
const configurable_input_type_1 = require("../configurable-input-type");
const number_ival_1 = require("./number-ival");
const Model = {
    min: 0,
    max: 100,
    step: 1,
    decimalPlaces: 1,
    defaultValue: 50
};
class NumberType extends configurable_input_type_1.ConfigurableInputType {
    constructor(config, key) {
        super(config || {}, key);
    }
    getInputTypeKey() {
        return NumberType.TYPE_NAME;
    }
    isNumeric() {
        return true;
    }
    createValue(cfg, key) {
        cfg = cfg || {};
        return new number_ival_1.NumberIval({
            value: isNumeric(cfg.value) ? cfg.value : this.defaultValue
        }, key || this.$key);
    }
}
exports.NumberType = NumberType;
NumberType.$model = core_1.ObjectUtil.assignDeep({}, configurable_input_type_1.ConfigurableInputType.$model, Model);
NumberType.TYPE_NAME = 'Number';
// Was once exposed. Alas. Thanks to https://github.com/angular/angular/blob/4.3.x/packages/common/src/pipes/number_pipe.ts#L172
function isNumeric(value) {
    return !isNaN(value - parseFloat(value));
}
exports.isNumeric = isNumeric;
configurable_input_type_1.ConfigurableInputType.register(NumberType);
//# sourceMappingURL=number-type.js.map