"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputConfig = void 0;
const core_1 = require("@tangential/core");
const media_types_1 = require("@tangential/media-types");
const configurable_input_type_1 = require("./data-type/configurable-input-type");
const Model = {
    $isSystem: false,
    _inputName: null,
    orderIndex: null,
    disabled: false,
    label: 'Label for this value',
    typeConfig: null
};
const inputConfigRegistry = {};
class InputConfig extends media_types_1.StampedMediaType {
    constructor(_inputName, config, key) {
        super(config, key);
        this._inputName = _inputName;
        this.typeConfig = configurable_input_type_1.ConfigurableInputType.create(this.typeConfig);
        if (this.$key === 'when') {
            this.$isSystem = true;
        }
    }
    static register(inputConfigCtor) {
        inputConfigRegistry[inputConfigCtor['INPUT_NAME']] = inputConfigCtor;
    }
    static create(config, key, inputName) {
        key = key || (config ? config.$key : null);
        inputName = inputName || (config ? config._inputName : null);
        return new inputConfigRegistry[inputName](config, key);
    }
}
exports.InputConfig = InputConfig;
InputConfig.$model = core_1.ObjectUtil.assignDeep({}, media_types_1.StampedMediaType.$model, Model);
//# sourceMappingURL=input-config.js.map