"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditConfigurableWidgetComponent = void 0;
const core_1 = require("@angular/core");
const dialog_1 = require("@angular/material/dialog");
const core_2 = require("@tangential/core");
const input_config_1 = require("../../input-config");
//noinspection ES6PreferShortImport
const choose_input_widget_dialog_1 = require("../choose-input-widget-dialog/choose-input-widget-dialog");
const input_types_registry_1 = require("../input-types-registry");
const input_view_mode_1 = require("../input-view-mode");
const i0 = require("@angular/core");
const i1 = require("../input-types-registry");
const i2 = require("@angular/material/dialog");
const i3 = require("@angular/common");
const i4 = require("@angular/material/button");
const i5 = require("../../../components/icon/icon.component");
const i6 = require("../template-components/input-template-component/input-template-container.component");
function EditConfigurableWidgetComponent_div_0_div_9_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 9)(1, "div", 10)(2, "tanj-input-template-container", 11);
    i0.ɵɵlistener("change", function EditConfigurableWidgetComponent_div_0_div_9_Template_tanj_input_template_container_change_2_listener() { i0.ɵɵrestoreView(_r3); const ctx_r2 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r2.onTemplateChanged(ctx_r2.inputTemplate)); });
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("inputConfig", ctx_r1.inputTemplate.config)("inputIval", ctx_r1.inputTemplate.ival)("mode", ctx_r1.inputTemplate.mode);
} }
function EditConfigurableWidgetComponent_div_0_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 1)(1, "fieldset", 2)(2, "legend");
    i0.ɵɵtext(3, "Preview");
    i0.ɵɵelementEnd();
    i0.ɵɵelement(4, "tanj-input-template-container", 3);
    i0.ɵɵelementStart(5, "div", 4)(6, "button", 5);
    i0.ɵɵlistener("click", function EditConfigurableWidgetComponent_div_0_Template_button_click_6_listener() { i0.ɵɵrestoreView(_r5); const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.showChooseInputDialog()); });
    i0.ɵɵelement(7, "tanj-icon", 6);
    i0.ɵɵelementEnd()()();
    i0.ɵɵelementStart(8, "div", 7);
    i0.ɵɵtemplate(9, EditConfigurableWidgetComponent_div_0_div_9_Template, 3, 3, "div", 8);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(4);
    i0.ɵɵproperty("inputConfig", ctx_r0.inputTemplate.config)("inputIval", ctx_r0.inputTemplate.ival)("mode", "EDIT");
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("disabled", !ctx_r0.canChangeWidget());
    i0.ɵɵadvance(3);
    i0.ɵɵproperty("ngIf", ctx_r0.inputTemplate);
} }
class EditConfigurableWidgetComponent {
    constructor(inputRegistry, changeDetectorRef, dialog) {
        this.inputRegistry = inputRegistry;
        this.changeDetectorRef = changeDetectorRef;
        this.dialog = dialog;
        this.inputConfigChange = new core_1.EventEmitter(false);
        this.inputNames = [];
    }
    ngOnInit() {
        this.inputNames = this.inputRegistry.inputNames;
        if (this.inputConfig) {
            this.updateInputConfig(this.inputConfig);
        }
    }
    ngOnChanges(changes) {
        if (changes.inputConfig) {
            this.updateInputConfig(this.inputConfig);
        }
    }
    inputWidgetChange(newConfig) {
        const inputName = newConfig._inputName;
        if (!this.inputConfig || inputName !== this.inputConfig._inputName) {
            const inputEntrySet = this.inputRegistry.getInputSet(inputName);
            const base = newConfig.toJson(true);
            if (this.inputConfig) {
                /** @todo: ggranum: Figure out why this is using label on a BaseMediaType model, that doesn't have a label field.  */
                base.label = this.inputConfig.label !== this.inputConfig.getModel().label
                    ? this.inputConfig.label
                    : null;
                base.orderIndex = this.inputConfig.orderIndex;
            }
            const newInputConfig = inputEntrySet.createInputConfig(base);
            newInputConfig._inputName = inputName;
            this.updateInputConfig(newInputConfig);
            this.inputConfigChange.emit(this.inputConfig);
        }
    }
    updateInputConfig(inputConfig) {
        this.inputConfig = inputConfig;
        const inputValue = inputConfig.typeConfig.createValue();
        this.inputTemplate = this.inputRegistry.createTemplateForType(inputConfig, input_view_mode_1.InputViewModes.CONFIGURE, inputValue);
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    canChangeWidget() {
        return !this.inputConfig.$isSystem;
    }
    showChooseInputDialog() {
        const dialogRef = this.dialog.open(choose_input_widget_dialog_1.ChooseInputWidgetDialog, {
            height: '80%',
            width: '100%',
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (result && result.config) {
                this.inputWidgetChange(result.config);
            }
        });
    }
    onTemplateChanged(template) {
        if (template.ival && template.ival.value !== template.config.typeConfig.defaultValue) {
            template.ival = template.config.typeConfig.createValue();
        }
    }
}
exports.EditConfigurableWidgetComponent = EditConfigurableWidgetComponent;
EditConfigurableWidgetComponent.ɵfac = function EditConfigurableWidgetComponent_Factory(t) { return new (t || EditConfigurableWidgetComponent)(i0.ɵɵdirectiveInject(i1.InputRegistry), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i2.MatDialog)); };
EditConfigurableWidgetComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: EditConfigurableWidgetComponent, selectors: [["tanj-edit-configurable-widget"]], inputs: { inputConfig: "inputConfig" }, outputs: { inputConfigChange: "inputConfigChange" }, features: [i0.ɵɵNgOnChangesFeature], decls: 1, vars: 1, consts: function () { let i18n_0; if (typeof ngI18nClosureMode !== "undefined" && ngI18nClosureMode) {
        /**
         * @suppress {msgDescriptions}
         */
        const MSG_EXTERNAL_8235267330427822584$$_____________________USERS_GGRANUM_GITHUB_GGRANUM_TANGENTIAL_SRC_LIB_CONFIGURABLE_INPUT_WIDGETS_SUPPORT_EDIT_CONFIGURABLE_WIDGET_COMPONENT_EDIT_CONFIGURABLE_WIDGET_COMPONENT_TS__1 = goog.getMsg("Choose Widget");
        i18n_0 = MSG_EXTERNAL_8235267330427822584$$_____________________USERS_GGRANUM_GITHUB_GGRANUM_TANGENTIAL_SRC_LIB_CONFIGURABLE_INPUT_WIDGETS_SUPPORT_EDIT_CONFIGURABLE_WIDGET_COMPONENT_EDIT_CONFIGURABLE_WIDGET_COMPONENT_TS__1;
    }
    else {
        i18n_0 = $localize `:␟604d1f1cf9062846e62f1c2391bd9342acb04fcf␟8235267330427822584:Choose Widget`;
    } return [["flex", "", "layout", "column", "layout-align", "space-between", 4, "ngIf"], ["flex", "", "layout", "column", "layout-align", "space-between"], ["layout", "row", "layout-align", "start", 1, "tanj-input-preview"], [3, "inputConfig", "inputIval", "mode"], ["layout", "row", "layout-align", "end"], ["mat-raised-button", "", "color", "primary", 1, "tanj-choose-widget-button", 3, "disabled", "click"], ["ligature", "edit", "label", i18n_0], ["flex", "", "layout", "column", "layout-align", "start", 1, "tanj-inputs-configuration-container"], ["flex", "70", "class", "tanj-input-configuration-inner", "layout", "column", "layout-align", "start", 4, "ngIf"], ["flex", "70", "layout", "column", "layout-align", "start", 1, "tanj-input-configuration-inner"], ["layout", "row", "layout-align", "start start"], ["flex", "", 3, "inputConfig", "inputIval", "mode", "change"]]; }, template: function EditConfigurableWidgetComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵtemplate(0, EditConfigurableWidgetComponent_div_0_Template, 10, 5, "div", 0);
    } if (rf & 2) {
        i0.ɵɵproperty("ngIf", ctx.inputConfig);
    } }, dependencies: [i3.NgIf, i4.MatButton, i5.IconComponent, i6.InputTemplateContainerComponent], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(EditConfigurableWidgetComponent, [{
        type: core_1.Component,
        args: [{ selector: 'tanj-edit-configurable-widget', encapsulation: core_1.ViewEncapsulation.None, changeDetection: core_1.ChangeDetectionStrategy.Default, template: "<div flex\n     *ngIf=\"inputConfig\"\n     layout=\"column\"\n     layout-align=\"space-between\">\n  <fieldset class=\"tanj-input-preview\" layout=\"row\" layout-align=\"start\">\n    <legend>Preview</legend>\n    <tanj-input-template-container [inputConfig]=\"inputTemplate.config\"\n                                  [inputIval]=\"inputTemplate.ival\"\n                                  [mode]=\"'EDIT'\"></tanj-input-template-container>\n    <div layout=\"row\" layout-align=\"end\">\n      <button class=\"tanj-choose-widget-button\"\n              mat-raised-button\n              color=\"primary\"\n              [disabled]=\"!canChangeWidget()\"\n              (click)=\"showChooseInputDialog()\">\n        <tanj-icon ligature=\"edit\" label=\"Choose Widget\" i18n-label></tanj-icon>\n      </button>\n    </div>\n  </fieldset>\n\n\n  <div flex class=\"tanj-inputs-configuration-container\" layout=\"column\" layout-align=\"start\">\n    <div flex=\"70\"\n         *ngIf=\"inputTemplate\"\n         class=\"tanj-input-configuration-inner\"\n         layout=\"column\"\n         layout-align=\"start\">\n      <div layout=\"row\" layout-align=\"start start\">\n        <tanj-input-template-container flex\n                                      [inputConfig]=\"inputTemplate.config\"\n                                      [inputIval]=\"inputTemplate.ival\"\n                                      [mode]=\"inputTemplate.mode\"\n                                      (change)=\"onTemplateChanged(inputTemplate)\"></tanj-input-template-container>\n      </div>\n    </div>\n  </div>\n</div>\n" }]
    }], function () { return [{ type: i1.InputRegistry }, { type: i0.ChangeDetectorRef }, { type: i2.MatDialog }]; }, { inputConfig: [{
            type: core_1.Input
        }], inputConfigChange: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=edit-configurable-widget.component.js.map