"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputTemplateContainerComponent = void 0;
const core_1 = require("@angular/core");
//noinspection ES6PreferShortImport
const configurable_input_ival_1 = require("../../../data-type/configurable-input-ival");
const input_config_1 = require("../../../input-config");
const input_types_registry_1 = require("../../input-types-registry");
const input_template_directive_1 = require("./input-template.directive");
const i0 = require("@angular/core");
const i1 = require("../../input-types-registry");
const i2 = require("./input-template.directive");
function InputTemplateContainerComponent_ng_template_0_Template(rf, ctx) { }
class InputTemplateContainerComponent {
    constructor(_typeRegistry, _componentFactoryResolver, _zone) {
        this._typeRegistry = _typeRegistry;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._zone = _zone;
        this.mode = null;
        this.hideLabel = false;
        this.onlyLabel = false;
        this.change = new core_1.EventEmitter(false);
    }
    ngAfterViewInit() {
    }
    ngOnDestroy() {
    }
    ngOnChanges(changes) {
        if (changes.template && this.template) {
            this.inputConfig = this.template.config;
            this.inputIval = this.template.ival;
            this.mode = this.template.mode;
            this.hideLabel = this.template.hideLabel;
            this.onlyLabel = this.template.onlyLabel;
        }
        if (this.inputConfig) {
            this.loadComponent();
        }
        else {
            console.warn('InputTemplateContainerComponent', 'No input type!', this.inputIval, this.mode);
        }
    }
    loadComponent() {
        this._zone.run(() => {
            const componentCtor = this._typeRegistry.getComponentCtorFor(this.inputConfig, this.mode);
            const componentFactory = this._componentFactoryResolver.resolveComponentFactory(componentCtor);
            const viewContainerRef = this.inputItemHost.viewContainerRef;
            viewContainerRef.clear();
            this._componentRef = viewContainerRef.createComponent(componentFactory);
            this._componentRef.instance.config = this.inputConfig;
            this._componentRef.instance.ival = this.inputIval;
            this._componentRef.instance.mode = this.mode;
            this._componentRef.instance.hideLabel = this.hideLabel;
            this._componentRef.instance.onlyLabel = this.onlyLabel;
            this._componentRef.instance.change = this.change;
            this._componentRef.changeDetectorRef.detectChanges();
        });
    }
}
exports.InputTemplateContainerComponent = InputTemplateContainerComponent;
InputTemplateContainerComponent.ɵfac = function InputTemplateContainerComponent_Factory(t) { return new (t || InputTemplateContainerComponent)(i0.ɵɵdirectiveInject(i1.InputRegistry), i0.ɵɵdirectiveInject(i0.ComponentFactoryResolver), i0.ɵɵdirectiveInject(i0.NgZone)); };
InputTemplateContainerComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: InputTemplateContainerComponent, selectors: [["tanj-input-template-container"]], viewQuery: function InputTemplateContainerComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(input_template_directive_1.InputTemplateDirective, 5);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.inputItemHost = _t.first);
    } }, inputs: { template: "template", inputConfig: "inputConfig", inputIval: "inputIval", mode: "mode", hideLabel: "hideLabel", onlyLabel: "onlyLabel" }, outputs: { change: "change" }, features: [i0.ɵɵNgOnChangesFeature], decls: 1, vars: 0, consts: [["tanj-input-template-host", ""]], template: function InputTemplateContainerComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵtemplate(0, InputTemplateContainerComponent_ng_template_0_Template, 0, 0, "ng-template", 0);
    } }, dependencies: [i2.InputTemplateDirective], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(InputTemplateContainerComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-input-template-container',
                template: `
              <ng-template tanj-input-template-host></ng-template>`,
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i1.InputRegistry }, { type: i0.ComponentFactoryResolver }, { type: i0.NgZone }]; }, { template: [{
            type: core_1.Input
        }], inputConfig: [{
            type: core_1.Input
        }], inputIval: [{
            type: core_1.Input
        }], mode: [{
            type: core_1.Input
        }], hideLabel: [{
            type: core_1.Input
        }], onlyLabel: [{
            type: core_1.Input
        }], change: [{
            type: core_1.Output
        }], inputItemHost: [{
            type: core_1.ViewChild,
            args: [input_template_directive_1.InputTemplateDirective]
        }] }); })();
//# sourceMappingURL=input-template-container.component.js.map