"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckboxWidgetConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const boolean_type_1 = require("../../data-type/boolean/boolean-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Checkbox',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: boolean_type_1.BooleanType.TYPE_NAME,
        defaultValue: false
    }
};
const demoConfig = core_1.ObjectUtil.assignDeep({}, Model, {
    label: 'Checkbox',
    labelPosition: 'before',
    typeConfig: {}
});
class CheckboxWidgetConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(CheckboxWidgetConfig.INPUT_NAME, config, key);
        this.typeConfig = new boolean_type_1.BooleanType(this.typeConfig);
    }
    getDemoInstance() {
        return new CheckboxWidgetConfig(demoConfig);
    }
}
exports.CheckboxWidgetConfig = CheckboxWidgetConfig;
CheckboxWidgetConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
CheckboxWidgetConfig.INPUT_NAME = 'Checkbox';
input_config_1.InputConfig.register(CheckboxWidgetConfig);
//# sourceMappingURL=checkbox-widget-config.js.map