"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateTimeInputConfig = void 0;
const core_1 = require("@tangential/core");
const moment = require("moment");
//noinspection ES6PreferShortImport
const date_time_type_1 = require("../../data-type/date-time/date-time-type");
//noinspection ES6PreferShortImport
const number_type_1 = require("../../data-type/number/number-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Date & Time',
    labelPosition: 'before',
    disabled: false,
    format: 'YYYY-MM-dd HH:mm:ss',
    typeConfig: {
        _inputTypeKey: number_type_1.NumberType.TYPE_NAME,
        defaultToNow: true,
        beforeMils: null,
        afterMils: null,
        defaultValue: moment().startOf('hour').valueOf()
    }
};
const demoConfig = Object.assign({}, Model);
console.log('Loading DateTimeInputConfig', '');
class DateTimeInputConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(DateTimeInputConfig.INPUT_NAME, config || {}, key);
        this.typeConfig = new date_time_type_1.DateTimeType(this.typeConfig);
    }
    getDemoInstance() {
        return new DateTimeInputConfig(demoConfig);
    }
}
exports.DateTimeInputConfig = DateTimeInputConfig;
DateTimeInputConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
DateTimeInputConfig.INPUT_NAME = 'DateTimeInput';
input_config_1.InputConfig.register(DateTimeInputConfig);
//# sourceMappingURL=date-time-input-config.js.map