"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationPickerConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const duration_type_1 = require("../../data-type/duration/duration-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Duration',
    labelPosition: 'before',
    showDurationFields: null,
    typeConfig: {
        _inputTypeKey: duration_type_1.DurationType.TYPE_NAME,
        defaultValue: 0
    }
};
const demoConfig = Object.assign({}, Model);
class DurationPickerConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(DurationPickerConfig.INPUT_NAME, config || {}, key);
        this.labelPosition = 'before';
        this.typeConfig = new duration_type_1.DurationType(this.typeConfig);
        if (!this.showDurationFields) {
            this.showDurationFields = {
                min: true,
                s: true,
                ms: true
            };
        }
    }
    getDemoInstance() {
        return new DurationPickerConfig(demoConfig);
    }
}
exports.DurationPickerConfig = DurationPickerConfig;
DurationPickerConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
DurationPickerConfig.INPUT_NAME = 'DurationPickerConfig';
input_config_1.InputConfig.register(DurationPickerConfig);
//# sourceMappingURL=duration-picker-config.js.map