"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconRatingWidgetConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const number_type_1 = require("../../data-type/number/number-type");
const input_config_1 = require("../../input-config");
const defaultIconCount = 5;
const Model = {
    label: 'Rating',
    labelPosition: 'below',
    iconFont: 'material-icons',
    offIconNames: [
        'star_border'
    ],
    onIconNames: [
        'star'
    ],
    disabled: false,
    typeConfig: {
        _inputTypeKey: number_type_1.NumberType.TYPE_NAME,
        defaultValue: defaultIconCount - 1,
        min: 0,
        max: defaultIconCount,
        step: 1,
        decimalPlaces: 0,
    }
};
const demoConfig = Object.assign({}, Model);
class IconRatingWidgetConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(IconRatingWidgetConfig.INPUT_NAME, config || {}, key);
        this.typeConfig = new number_type_1.NumberType(this.typeConfig);
        if (this.typeConfig.max > 10) {
            this.typeConfig.max = 10;
        }
    }
    getDemoInstance() {
        return new IconRatingWidgetConfig(demoConfig);
    }
}
exports.IconRatingWidgetConfig = IconRatingWidgetConfig;
IconRatingWidgetConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
IconRatingWidgetConfig.INPUT_NAME = 'IconRatingWidget';
input_config_1.InputConfig.register(IconRatingWidgetConfig);
//# sourceMappingURL=icon-rating-widget-config.js.map