"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberInputConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const number_type_1 = require("../../data-type/number/number-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Number',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: number_type_1.NumberType.TYPE_NAME,
        defaultValue: 0
    }
};
const demoConfig = Object.assign({}, Model);
class NumberInputConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(NumberInputConfig.INPUT_NAME, config || {}, key);
        this.typeConfig = new number_type_1.NumberType(this.typeConfig);
    }
    getDemoInstance() {
        return new NumberInputConfig(demoConfig);
    }
}
exports.NumberInputConfig = NumberInputConfig;
NumberInputConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
NumberInputConfig.INPUT_NAME = 'NumberInput';
input_config_1.InputConfig.register(NumberInputConfig);
//# sourceMappingURL=number-input-config.js.map