"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberSliderConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const number_type_1 = require("../../data-type/number/number-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Number Slider',
    labelPosition: 'below',
    disabled: false,
    typeConfig: {
        _inputTypeKey: number_type_1.NumberType.TYPE_NAME,
        defaultValue: 0
    }
};
const demoConfig = Object.assign({}, Model);
class NumberSliderConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(NumberSliderConfig.INPUT_NAME, config || {}, key);
        this.typeConfig = new number_type_1.NumberType(this.typeConfig);
    }
    getDemoInstance() {
        return new NumberSliderConfig(demoConfig);
    }
}
exports.NumberSliderConfig = NumberSliderConfig;
NumberSliderConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
NumberSliderConfig.INPUT_NAME = 'NumberSlider';
input_config_1.InputConfig.register(NumberSliderConfig);
//# sourceMappingURL=number-slider-config.js.map