"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberSpinnerConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const number_type_1 = require("../../data-type/number/number-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Number Spinner',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: number_type_1.NumberType.TYPE_NAME,
        defaultValue: 0
    }
};
const demoConfig = Object.assign({}, Model, {
    label: 'Number Spinner'
});
class NumberSpinnerConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(NumberSpinnerConfig.INPUT_NAME, config || {}, key);
        this.typeConfig = new number_type_1.NumberType(super.typeConfig);
    }
    getDemoInstance() {
        return new NumberSpinnerConfig(demoConfig);
    }
}
exports.NumberSpinnerConfig = NumberSpinnerConfig;
NumberSpinnerConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
NumberSpinnerConfig.INPUT_NAME = 'NumberSpinner';
input_config_1.InputConfig.register(NumberSpinnerConfig);
//# sourceMappingURL=number-spinner-config.js.map