"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlideToggleConfig = void 0;
const core_1 = require("@tangential/core");
//noinspection ES6PreferShortImport
const boolean_type_1 = require("../../data-type/boolean/boolean-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Slide Toggle',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: boolean_type_1.BooleanType.TYPE_NAME,
        defaultValue: false
    }
};
const demoConfig = {
    label: 'Slide Toggle',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: boolean_type_1.BooleanType.TYPE_NAME,
        defaultValue: false
    }
};
class SlideToggleConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(SlideToggleConfig.INPUT_NAME, config || {}, key);
        this.labelPosition = 'before';
        this.disabled = false;
        this.typeConfig = new boolean_type_1.BooleanType(super.typeConfig);
    }
    getDemoInstance() {
        return new SlideToggleConfig(demoConfig);
    }
}
exports.SlideToggleConfig = SlideToggleConfig;
SlideToggleConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
SlideToggleConfig.INPUT_NAME = 'SlideToggle';
input_config_1.InputConfig.register(SlideToggleConfig);
//# sourceMappingURL=slide-toggle-widget-config.js.map