"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextInputConfig = void 0;
const core_1 = require("@tangential/core");
const text_type_1 = require("../../data-type/text/text-type");
const input_config_1 = require("../../input-config");
const Model = {
    label: 'Short Text',
    labelPosition: 'before',
    disabled: false,
    typeConfig: {
        _inputTypeKey: text_type_1.TextType.TYPE_NAME,
        maxLength: 100,
        defaultValue: undefined
    }
};
const demoConfig = core_1.ObjectUtil.assignDeep({}, Model, {
    typeConfig: {
        maxLength: 100,
        defaultValue: undefined
    }
});
class TextInputConfig extends input_config_1.InputConfig {
    constructor(config, key) {
        super(TextInputConfig.INPUT_NAME, config || {}, key);
        this.labelPosition = 'before';
        /** @todo: ggranum: Verify we need these fields (they already exist on superclass) */
        this.disabled = false;
        /** @todo: ggranum: Verify this change (this.typeConfig to super.typeConfig) works. */
        this.typeConfig = new text_type_1.TextType(super.typeConfig || {});
    }
    getDemoInstance() {
        return new TextInputConfig(demoConfig);
    }
}
exports.TextInputConfig = TextInputConfig;
TextInputConfig.$model = core_1.ObjectUtil.assignDeep({}, input_config_1.InputConfig.$model, Model);
TextInputConfig.INPUT_NAME = 'TextInput';
input_config_1.InputConfig.register(TextInputConfig);
//# sourceMappingURL=text-input-config.js.map